/***************************************************************************
    NWNX Time - Timer functions plugin
    Copyright (C) 2006 Ingmar Stieger (Papillon, papillon@blackdagger.com) 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 ***************************************************************************/

/*

	---------------------------------------------------------------------------------------
	Date		Name		Reason
	---------------------------------------------------------------------------------------
	010107		KFW			Initial.
	081107		CarterDC	Refactored to NWNX4 1.08.
	081807		KFW			Syntax check.
	081807		KFW			Mapsize fix to NWNX4Clock module.
    101208      KFW         Compiled for NWNX4 1.09 and NWN2 1.13.
	---------------------------------------------------------------------------------------

*/


// Definitions.
#if !defined(CLOCK_H_INCLUDED)
#define CLOCK_H_INCLUDED

#define DLLEXPORT extern "C" __declspec(dllexport)
#define CLOCK_VERSION "0.0.1.0"

// Includes.
#include "windows.h"
#include "../plugin.h"
#include "../../misc/log.h"
#include "wx/tokenzr.h"
#include "wx/hashset.h"
#include "strsafe.h"

// Type definitions.
typedef FARPROC ( WINAPI * pRtlTimeToSecondsSince1970 ) ( PLARGE_INTEGER p_nTime, PULONG p_ulSeconds );

// Classes.
class Clock : public Plugin{

public:

	Clock( );
	~Clock( );

	bool Init(TCHAR* nwnxhome);

	INT GetInt( PCHAR psFunction, PCHAR psParam1, INT nParam2 ){ return( 0 ); }
	VOID SetInt( PCHAR psFunction, PCHAR psParam1, INT nParam2, INT nValue ){ };
	FLOAT GetFloat( PCHAR psFunction, PCHAR psParam1, INT nParam2 ){ return( 0.0 ); }
	VOID SetFloat( PCHAR psFunction, PCHAR psParam1, INT nParam2, FLOAT fValue ){ };

	VOID SetString( PCHAR psFunction, PCHAR psParam1, INT nParam2, PCHAR psValue );
	PCHAR GetString( PCHAR psFunction, PCHAR psParam1, INT nParam2 );

	VOID GetFunctionClass( TCHAR * fClass );

	VOID WriteNWN2String( PCHAR pszNWN2String );	// This method will write text to NWN2's NWNXGetString(..) return value.

private:

	wxLogNWNX * logger;

	SYSTEMTIME SystemTime;
	INT UpdateClock( );					// This method refreshes the class' date and time information.
	VOID GetDate( );					// This method returns the date in the format (mm/dd/yyyy) back to the NWN2 game.
	VOID GetTime( );					// This method returns the time in the format (hh:mm:ss) back to the NWN2 game.
	VOID GetUNIXTime( );				// This method returns the time since in seconds since Jan 1st 1970 back to the NWN2 game.

};

#endif